VERSION 2.00
Begin Form VB3EX 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "VISUAL BASICS #3 Example"
   ClientHeight    =   3435
   ClientLeft      =   1485
   ClientTop       =   1530
   ClientWidth     =   4980
   Height          =   3840
   Left            =   1425
   LinkMode        =   1  'Source
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   3435
   ScaleWidth      =   4980
   Top             =   1185
   Width           =   5100
   Begin CommandButton BtnQuit 
      Cancel          =   -1  'True
      Caption         =   "&Quit"
      Height          =   375
      Left            =   3600
      TabIndex        =   7
      Top             =   2880
      Width           =   1035
   End
   Begin CommandButton BtnEdit 
      Caption         =   "&&Edit"
      Height          =   375
      Left            =   2460
      TabIndex        =   6
      Top             =   2880
      Width           =   1035
   End
   Begin CommandButton BtnRead 
      Caption         =   "&Read"
      Height          =   375
      Left            =   1380
      TabIndex        =   5
      Top             =   2880
      Width           =   1035
   End
   Begin CommandButton BtnWrite 
      Caption         =   "&Write"
      Height          =   375
      Left            =   240
      TabIndex        =   4
      Top             =   2880
      Width           =   1035
   End
   Begin TextBox TxtValue 
      Height          =   375
      Left            =   1440
      TabIndex        =   3
      Top             =   2280
      Width           =   2895
   End
   Begin TextBox TxtKey 
      Height          =   375
      Left            =   1440
      TabIndex        =   2
      Top             =   1800
      Width           =   2895
   End
   Begin TextBox TxtSection 
      Height          =   375
      Left            =   1440
      TabIndex        =   1
      Top             =   1320
      Width           =   2895
   End
   Begin TextBox TxtINIFile 
      Height          =   375
      Left            =   1440
      TabIndex        =   0
      Top             =   840
      Width           =   2895
   End
   Begin Label LblValue 
      Alignment       =   1  'Right Justify
      Caption         =   "Value:"
      Height          =   255
      Left            =   240
      TabIndex        =   11
      Top             =   2340
      Width           =   1095
   End
   Begin Label LblKey 
      Alignment       =   1  'Right Justify
      Caption         =   "Key:"
      Height          =   255
      Left            =   240
      TabIndex        =   10
      Top             =   1860
      Width           =   1095
   End
   Begin Label LblSection 
      Alignment       =   1  'Right Justify
      Caption         =   "Section:"
      Height          =   255
      Left            =   240
      TabIndex        =   9
      Top             =   1380
      Width           =   1095
   End
   Begin Label LblINIFile 
      Alignment       =   1  'Right Justify
      Caption         =   "INI File:"
      Height          =   255
      Left            =   300
      TabIndex        =   12
      Top             =   900
      Width           =   1095
   End
   Begin Label LblMessages 
      ForeColor       =   &H00000080&
      Height          =   315
      Left            =   120
      TabIndex        =   13
      Top             =   420
      Width           =   4335
   End
   Begin Label LblWinDir 
      Caption         =   "Windows Directory:"
      Height          =   255
      Left            =   120
      TabIndex        =   8
      Top             =   120
      Width           =   4215
   End
End
DefInt A-Z
Dim WindowsDirectory As String
Dim INIFileName As String
'Windows API calls!  Get 'em while they're hot!


'learn about your environment.......................................................
Declare Function GetWindowsDirectory Lib "Kernel" (ByVal lpBuffer As String, ByVal nSize As Integer) As Integer

'read/write your application's 'private' INI file ......................................
Declare Function GetPrivateProfileString Lib "Kernel" (ByVal SectionName As String, ByVal KeyName As String, ByVal Default As String, ByVal ReturnedString As String, ByVal MaxSize, ByVal FileName As String)
Declare Function WritePrivateProfileString Lib "Kernel" (ByVal SectionName As String, ByVal KeyName As String, ByVal NewString As String, ByVal FileName As String)

Sub BtnEdit_Click ()
    LblMessages.Caption = "Editing " + WindowsDirectory + "\" + UCase$(TxtINIFile.Text) + "."
    LblMessages.Refresh
    Screen.MousePointer = 11
    ShellStr$ = "NOTEPAD.EXE " + WindowsDirectory + "\" + UCase$(TxtINIFile.Text)
    ShelRes% = Shell(ShellStr$, 1)
    Screen.MousePointer = 0
    LblMessages.Caption = ""
End Sub

Sub BtnQuit_Click ()
    End
End Sub

Sub BtnRead_Click ()
    If TxtINIFile.Text = "" Then
        Beep
        TxtINIFile.SetFocus
        Exit Sub
    End If
    
    If TxtSection.Text = "" Then
        Beep
        TxtSection.SetFocus
        Exit Sub
    End If
    
    If TxtKey.Text = "" Then
        Beep
        TxtKey.SetFocus
        Exit Sub
    End If
    
    
    'Assign textbox contents to variables for API call.
    '(API call won't take references to Textbox contents.)
    Sectn$ = TxtSection.Text
    Keyy$ = TxtKey.Text
    DeeFalt$ = ""
    FileNam$ = WindowsDirectory + "\" + TxtINIFile.Text
    
    TxtValue.Text = StringFromINI(Sectn$, Keyy$, DeeFalt$, FileNam$)

    If TxtValue.Text = "" Then
        LblMessages.Caption = "Section, Key or File name not found."
    Else
        LblMessages.Caption = "Read SUCCEEDED."
    End If
    
End Sub

Sub BtnWrite_Click ()
    If TxtSection.Text = "" Then
        Beep
        TxtSection.SetFocus
        Exit Sub
    End If

    If TxtKey.Text = "" Then
        Beep
        TxtKey.SetFocus
        Exit Sub
    End If
    
    Sectn$ = TxtSection.Text
    Keyy$ = TxtKey.Text
    Valyue$ = TxtValue.Text
    FileNam$ = WindowsDirectory + "\" + TxtINIFile.Text

    Result% = StringToINI(Sectn$, Keyy$, Valyue$, FileNam$)
    If Result% = 0 Then
        LblMessages.Caption = "Write FAILED."
    Else
        LblMessages.Caption = "Write SUCCEEDED."
    End If

End Sub

Sub Form_Load ()
    WindowsDirectory = WinDir()
    INIFileName = "VB3EX.INI"
    LblWindir.Caption = "Windows Directory: " + UCase$(WindowsDirectory)
    TxtINIFile.Text = INIFileName
End Sub

Function StringFromINI (SectionName As String, KeyName As String, Default As String, FileName As String) As String

'Function reads an item from an app's INI file.
'   -SectionName is the Application name
'   -KeyName is the Key to read from the ini file
'   -Default is the value to be supplied if the ini file doesn't exist or if the key
'       hasn't been created/defined in the INI file.
'   -ReturnedString is the string read from the INI file
'   -ReturnedStringLen is the max allowable length of ReturnedString
'   -FileName is the INI file name.
'
'ALL OF THESE PARAMETERS MUST BE INITIALIZED for this API call to work.

    MaxStringLen% = 255
    ReturnedStr$ = Space$(MaxStringLen%)

    Result% = GetPrivateProfileString(SectionName, KeyName, Default, ReturnedStr$, MaxStringLen%, FileName)
    ResultStr$ = LTrim$(RTrim$(ReturnedStr$)) ' TRIM OUT BLANKS
    ResultStr$ = Left$(ResultStr$, Len(ResultStr$) - 1) ' REMOVE CHR$(0) FROM END
    StringFromINI = ResultStr$
End Function

Function StringToINI (SectionName As String, KeyName As String, DataString As String, INIFileName As String) As Integer
    StringToINI = WritePrivateProfileString(SectionName, KeyName, DataString, INIFileName)
End Function

Function WinDir$ ()
'Author:            Barry Seymour, Vanguard Business Solutions
'Date:              29Aug91
'Globals used:      None
'Functions Called:  GetWindowsDirectory, defined in GLOBAL.BAS as follows:
'--------------------------------------------------------------------------------------------------------------
'Declare Function GetWindowsDirectory Lib "Kernel" (ByVal lpBuffer As String, ByVal nSize As Integer) As Integer
'---------------------------------------------------------------------------------------------------------------

'Explanation:   This Function returns a string containing the
'               name of the Windows directory.  The GetWindowsDirectory
'               function call is defined in GLOBAL.BAS (see above)
'               and uses a Windows API call to the Kernel.

' IMPORTANT NOTE:   The string to contain the returned data MUST be fully
' initialized prior to placing data in it, else an Unrecoverable
' Application Error (UAE) will result.  This Function initializes the
' string with empty spaces so the result can be trimmed.
' EVEN SO, the result string has a null char at the end of it which
' must be stripped away manually - RTrim$ or LTrim$ don't strip out
' null chars.
'
' ANOTHER IMPORTANT NOTE:  If your windows directory is in the ROOT, a
' backslash is at the end of the string ("C:\").  If not, there is no
' backslash at the end of the string ("C:\WINDOWS").

'Error trapping is also in this code, giving a STERN WARNING to the user.
'If this procedure fails, your system is mightily confused.
'----------------------------------------------------------------------------

    LF$ = Chr$(13) + Chr$(10)  'linefeed for message formatting
    
    PathStringLength% = 255 'The length is arbitrary, but MUST be defined.
    
    WindowsPathName$ = String$(PathStringLength%, " ")
    'Initialize the full string to SPACES.  The full length of the
    'string MUST be present before making the function call, else UAE!
    
    Success% = GetWindowsDirectory(WindowsPathName$, PathStringLength%)
    If Success% Then
        WinDir$ = Left$(RTrim$(WindowsPathName$), Len(RTrim$(WindowsPathName$)) - 1)
        '                   |--Trim trailing blanks   |-Trim null char at end of string.
    Else
        WinDir = "C:\WINDOWS"
        Msg$ = "SYSTEM ERROR: Unable to determine Windows Directory." + LF$
        If Err <> 0 Then
            Msg$ = Msg$ + "Error " + Str$(Err) + ":" + LF$
            Msg$ = Msg$ + Error$(Err) + "." + LF$
        Else
            Msg$ = Msg$ + LF$ + "Error Number Unknown." + LF$
        End If
        Msg$ = Msg$ + "Assuming Windows Directory to be C:\WINDOWS." + LF$ + LF$
        Msg$ = Msg$ + "It is STRONGLY RECOMMENDED that you save your work " + LF$
        Msg$ = Msg$ + "and SHUT DOWN this application."
        Beep: Beep: Beep: MsgBox Msg$, 16, "System Error"
    End If
End Function

